jQuery(document).ready(function () {

    jQuery( "label[for='estes_freight_handling_weight']" ).addClass( 'estes_freight_handling_weight' );
    jQuery( "label[for='estes_freight_maximum_handling_weight']" ).addClass( 'estes_freight_handling_weight' );
    jQuery("#estes_freight_handling_weight").attr('maxlength','8');
    jQuery("#estes_freight_maximum_handling_weight").attr('maxlength','8');

    en_weight_threshold_limit();

    // White Glove
    if (jQuery("#estes_inside_delivery").length) {
        jQuery("#estes_inside_delivery").closest('tr').addClass("estes_inside_delivery");
        jQuery("#en_woo_addons_inside_with_auto_residential").closest('tr').addClass("en_woo_addons_inside_with_auto_residential");
    }

    // Cuttoff Time
    jQuery("#estes_freight_shipment_offset_days").closest('tr').addClass("estes_freight_shipment_offset_days_tr");
    jQuery("#all_shipment_days_estes").closest('tr').addClass("all_shipment_days_estes_tr");
    jQuery(".estes_shipment_day").closest('tr').addClass("estes_shipment_day_tr");
    jQuery("#estes_freight_order_cut_off_time").closest('tr').addClass("estes_freight_cutt_off_time_ship_date_offset");
    var estes_current_time = en_estes_admin_script.estes_freight_order_cutoff_time;
    if (estes_current_time == '') {

        jQuery('#estes_freight_order_cut_off_time').wickedpicker({
            now: '',
            title: 'Cut Off Time',
        });
    } else {
        jQuery('#estes_freight_order_cut_off_time').wickedpicker({

            now: estes_current_time,
            title: 'Cut Off Time'
        });
    }

    var delivery_estimate_val = jQuery('input[name=estes_delivery_estimates]:checked').val();
    if (delivery_estimate_val == 'dont_show_estimates') {
        jQuery("#estes_freight_order_cut_off_time").prop('disabled', true);
        jQuery("#estes_freight_shipment_offset_days").prop('disabled', true);
        jQuery("#estes_freight_shipment_offset_days").css("cursor", "not-allowed");
        jQuery("#estes_freight_order_cut_off_time").css("cursor", "not-allowed");
    } else {
        jQuery("#estes_freight_order_cut_off_time").prop('disabled', false);
        jQuery("#estes_freight_shipment_offset_days").prop('disabled', false);
        // jQuery("#estes_freight_order_cut_off_time").css("cursor", "auto");
        jQuery("#estes_freight_order_cut_off_time").css("cursor", "");
    }

    jQuery("input[name=estes_delivery_estimates]").change(function () {
        var delivery_estimate_val = jQuery('input[name=estes_delivery_estimates]:checked').val();
        if (delivery_estimate_val == 'dont_show_estimates') {
            jQuery("#estes_freight_order_cut_off_time").prop('disabled', true);
            jQuery("#estes_freight_shipment_offset_days").prop('disabled', true);
            jQuery("#estes_freight_order_cut_off_time").css("cursor", "not-allowed");
            jQuery("#estes_freight_shipment_offset_days").css("cursor", "not-allowed");
        } else {
            jQuery("#estes_freight_order_cut_off_time").prop('disabled', false);
            jQuery("#estes_freight_shipment_offset_days").prop('disabled', false);
            jQuery("#estes_freight_order_cut_off_time").css("cursor", "auto");
            jQuery("#estes_freight_shipment_offset_days").css("cursor", "auto");
        }
    });

    /*
     * Uncheck Week days Select All Checkbox
     */
    jQuery(".estes_shipment_day").on('change load', function () {

        var checkboxes = jQuery('.estes_shipment_day:checked').length;
        var un_checkboxes = jQuery('.estes_shipment_day').length;
        if (checkboxes === un_checkboxes) {
            jQuery('.all_shipment_days_estes').prop('checked', true);
        } else {
            jQuery('.all_shipment_days_estes').prop('checked', false);
        }
    });

    /*
     * Select All Shipment Week days
     */

    var all_int_checkboxes = jQuery('.all_shipment_days_estes');
    if (all_int_checkboxes.length === all_int_checkboxes.filter(":checked").length) {
        jQuery('.all_shipment_days_estes').prop('checked', true);
    }

    jQuery(".all_shipment_days_estes").change(function () {
        if (this.checked) {
            jQuery(".estes_shipment_day").each(function () {
                this.checked = true;
            });
        } else {
            jQuery(".estes_shipment_day").each(function () {
                this.checked = false;
            });
        }
    });


    //** End: Order Cut Off Time

    //          JS for edit product nested fields
    jQuery("._nestedMaterials").closest('p').addClass("_nestedMaterials_tr");
    jQuery("._nestedPercentage").closest('p').addClass("_nestedPercentage_tr");
    jQuery("._maxNestedItems").closest('p').addClass("_maxNestedItems_tr");
    jQuery("._nestedDimension").closest('p').addClass("_nestedDimension_tr");
    jQuery("._nestedStakingProperty").closest('p').addClass("_nestedStakingProperty_tr");

    if (!jQuery('._nestedMaterials').is(":checked")) {
        jQuery('._nestedPercentage_tr').hide();
        jQuery('._nestedDimension_tr').hide();
        jQuery('._maxNestedItems_tr').hide();
        jQuery('._nestedDimension_tr').hide();
        jQuery('._nestedStakingProperty_tr').hide();
    } else {
        jQuery('._nestedPercentage_tr').show();
        jQuery('._nestedDimension_tr').show();
        jQuery('._maxNestedItems_tr').show();
        jQuery('._nestedDimension_tr').show();
        jQuery('._nestedStakingProperty_tr').show();
    }

    jQuery("._nestedPercentage").attr('min', '0');
    jQuery("._maxNestedItems").attr('min', '0');
    jQuery("._nestedPercentage").attr('max', '100');
    jQuery("._maxNestedItems").attr('max', '100');
    jQuery("._nestedPercentage").attr('maxlength', '3');
    jQuery("._maxNestedItems").attr('maxlength', '3');

    if (jQuery("._nestedPercentage").val() == '') {
        jQuery("._nestedPercentage").val(0);
    }

    jQuery("._nestedPercentage").keydown(function (eve) {
        Estes_lfq_stop_special_characters(eve);
        var nestedPercentage = jQuery('._nestedPercentage').val();
        if (nestedPercentage.length == 2) {
            var newValue = nestedPercentage + '' + eve.key;
            if (newValue > 100) {
                return false;
            }
        }
    });

    jQuery("._nestedDimension").keydown(function (eve) {
        Estes_lfq_stop_special_characters(eve);
        var nestedDimension = jQuery('._nestedDimension').val();
        if (nestedDimension.length == 2) {
            var newValue1 = nestedDimension + '' + eve.key;
            if (newValue1 > 100) {
                return false;
            }
        }
    });

    jQuery("._maxNestedItems").keydown(function (eve) {
        Estes_lfq_stop_special_characters(eve);
    });

    jQuery("._nestedMaterials").change(function () {
        if (!jQuery('._nestedMaterials').is(":checked")) {
            jQuery('._nestedPercentage_tr').hide();
            jQuery('._nestedDimension_tr').hide();
            jQuery('._maxNestedItems_tr').hide();
            jQuery('._nestedDimension_tr').hide();
            jQuery('._nestedStakingProperty_tr').hide();
        } else {
            jQuery('._nestedPercentage_tr').show();
            jQuery('._nestedDimension_tr').show();
            jQuery('._maxNestedItems_tr').show();
            jQuery('._nestedDimension_tr').show();
            jQuery('._nestedStakingProperty_tr').show();
        }
    });

    jQuery("#estes_freight_hold_at_terminal_fee").focus(function (e) {
        jQuery("#" + this.id).css({'border-color': '#ddd'});
    });
    jQuery("#estes_freight_hold_at_terminal_checkbox_status").closest('tr').addClass("estes_freight_hold_at_terminal_checkbox_status");
    jQuery("#estes_freight_hold_at_terminal_fee").closest('tr').addClass("estes_freight_hold_at_terminal_fee_tr");

    jQuery("#estes_setting_residential").closest('tr').addClass("estes_setting_residential");
    jQuery("#avaibility_auto_residential").closest('tr').addClass("avaibility_auto_residential");
    jQuery("#avaibility_lift_gate").closest('tr').addClass("avaibility_lift_gate");
    jQuery("#estes_settings_liftgate").closest('tr').addClass("estes_settings_liftgate");
    //**Start : Carriers
    jQuery("#ltl_standard_transit").closest('tr').addClass("estes_settings_liftgate");
    jQuery("#guaranteed_ltl_standard_transit_5mp").closest('tr').addClass("estes_settings_liftgate");
    jQuery("#guaranteed_ltl_standard_transit_12mp").closest('tr').addClass("estes_settings_liftgate");
    jQuery("#guaranteed_ltl_standard_transit_10am").closest('tr').addClass("estes_settings_liftgate");
    //**End : Carriers
    jQuery("#estes_ltl_quotes_liftgate_delivery_as_option").closest('tr').addClass("estes_ltl_quotes_liftgate_delivery_as_option");
    jQuery("#order_shipping_line_items .shipping .view .display_meta").css('display', 'none');
    //****** Start: Select All Services

    jQuery(".EstesCheckboxClass").change(function () {
        if (this.checked) {
            jQuery(".estes_settings_carriers").each(function () {
                this.checked = true;
            });
        } else {
            jQuery(".estes_settings_carriers").each(function () {
                this.checked = false;
            });
        }
    });


    //****** Start: Select All Services

    jQuery(".estes_settings_carriers").on('change load', function () {
        var checkboxes = jQuery('.estes_settings_carriers:checked').length;
        var un_checkboxes = jQuery('.estes_settings_carriers').length;

        if (checkboxes === un_checkboxes) {
            jQuery('.EstesCheckboxClass').prop('checked', true);
        } else {
            jQuery('.EstesCheckboxClass').prop('checked', false);
        }
    });

    //*****Start: Handling Fee Validation

    jQuery("#estes_settings_handling_fee,#estes_freight_handling_weight,#estes_freight_maximum_handling_weight").keydown(function (e) {
        // Allow: backspace, delete, tab, escape, enter and .
        if (jQuery.inArray(e.keyCode, [46, 8, 9, 27, 13, 110, 190]) !== -1 ||
            // Allow: Ctrl+A, Command+A
            (e.keyCode === 65 && (e.ctrlKey === true || e.metaKey === true)) ||
            // Allow: home, end, left, right, down, up
            (e.keyCode >= 35 && e.keyCode <= 40)|| e.keyCode == 109) {
            // let it happen, don't do anything
            return;
        }
        if(e.target.id == 'estes_settings_handling_fee')
        {
            if (jQuery.inArray(e.keyCode, [53,189]) !== -1  ){
                return;
            }
        }
        // Ensure that it is a number and stop the keypress
        if ((e.keyCode === 190 || e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) {
            e.preventDefault();
        }

        if ((jQuery(this).val().indexOf('.') != -1) && (jQuery(this).val().substring(jQuery(this).val().indexOf('.'), jQuery(this).val().indexOf('.').length).length > 2)) {
            if (event.keyCode !== 8 && event.keyCode !== 46) { //exception
                event.preventDefault();
            }
        }

    });
    jQuery("#estes_settings_handling_fee,#estes_freight_handling_weight,#estes_freight_maximum_handling_weight, #en_wd_origin_markup, #en_wd_dropship_markup, ._en_product_markup").keyup(function (e) {

        var val = jQuery(this).val();

        if (val.length && val.includes('%')) {
            jQuery(this).val(val.substring(0, val.indexOf('%') + 1));
        }

        if (val.split('.').length - 1 > 1) {
            var newval = val.substring(0, val.length - 1);
            var countDots = newval.substring(newval.indexOf('.') + 1).length;
            newval = newval.substring(0, val.length - countDots - 1);
            jQuery(this).val(newval);
        }

        if (val.split('%').length - 1 > 1) {
            var newval = val.substring(0, val.length - 1);
            var countPercentages = newval.substring(newval.indexOf('%') + 1).length;
            newval = newval.substring(0, val.length - countPercentages - 1);
            jQuery(this).val(newval);
        }

        if (val.split('-').length - 1 > 1) {
            var newval = val.substring(0, val.length - 1);
            var countPercentages = newval.substring(newval.indexOf('-') + 1).length;
            newval = newval.substring(0, val.length - countPercentages - 1);
            jQuery(this).val(newval);
        }
    });
    //*****End: Handling Fee Validation

    jQuery("#en_wd_origin_markup, ._en_product_markup").bind("cut copy paste",function(e) {
        e.preventDefault();
    });
    
    jQuery("#en_wd_origin_markup, ._en_product_markup").keypress(function (e) {
        if (!String.fromCharCode(e.keyCode).match(/^[-0-9\d\.%\s]+$/i)) return false;
    });

    jQuery("#en_wd_origin_markup, ._en_product_markup").keydown(function (e) {
        const val = jQuery(this).val();

        if ((e.keyCode === 109 || e.keyCode === 189) && (val.length > 0)) return false;
        if (e.keyCode === 53) if (e.shiftKey) if (val.length == 0) return false; 
        
        if ((val.indexOf('.') != -1) && (val.substring(val.indexOf('.'), val.indexOf('.').length).length > 2)) {
            if (e.keyCode !== 8 && e.keyCode !== 46) { //exception
                e.preventDefault();
            }
        }

        // Allow: backspace, delete, tab, escape, enter and .
        if (jQuery.inArray(e.keyCode, [46, 8, 9, 27, 13, 110, 190, 53, 189]) !== -1 ||
            // Allow: Ctrl+A, Command+A
            (e.keyCode === 65 && (e.ctrlKey === true || e.metaKey === true)) ||
            // Allow: home, end, left, right, down, up
            (e.keyCode >= 35 && e.keyCode <= 40)) {
            // let it happen, don't do anything
            return;
        }

        // Ensure that it is a number and stop the keypress
        if (val.length > 7 || (e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) {
            e.preventDefault();
        }
    });

    /**
     * Offer lift gate delivery as an option and Always include residential delivery fee
     * @returns {undefined}
     */

    jQuery(".checkbox_fr_add").on("click", function () {
        var id = jQuery(this).attr("id");
        if (id == "estes_settings_liftgate") {
            jQuery("#estes_ltl_quotes_liftgate_delivery_as_option").prop({checked: false});
            jQuery("#en_woo_addons_liftgate_with_auto_residential").prop({checked: false});
        } else if (id == "estes_ltl_quotes_liftgate_delivery_as_option" ||
            id == "en_woo_addons_liftgate_with_auto_residential") {
            jQuery("#estes_settings_liftgate").prop({checked: false});
        } else if (id == "estes_inside_delivery") { // White Glove
            jQuery("#en_woo_addons_inside_with_auto_residential").prop({checked: false});
        } else if (id == "en_woo_addons_inside_with_auto_residential") {
            jQuery("#estes_inside_delivery").prop({checked: false});
        }
    });

    var url = get_url_vars_estes_freight()["tab"];
    if (url === 'estes_ltl_quotes') {
        jQuery('#footer-left').attr('id', 'wc-footer-left');
    }
    /*
    * Add err class on connection settings page
    */
    jQuery('.estes_tab_section input[type="text"]').each(function () {
        if (jQuery(this).parent().find('.err').length < 1) {
            jQuery(this).after('<span class="err"></span>');
        }
    });

    /*
    * Show Note Message on Connection Settings Page
    */

    jQuery('.estes_tab_section .form-table').before("<div class='warning-msg'><p>Note! You must have an Estes Express account to use this application. If you do not have one, contact Estes Express at 866-378-3748, or email <a href='mailto:customercare@estes-express.com' target='_parent' >customercare@estes-express.com</a>.</p></div>");

    /*
    * Add maxlength Attribute on Handling Fee Quote Setting Page
    */

    jQuery("#estes_settings_handling_fee").attr('maxlength', '8');

    /*
     * Add Title To Connection Setting Fields
     */

    jQuery('#estes_setting_customer_no').attr('title', 'Customer Number');
    jQuery('#estes_setting_username').attr('title', 'Username');
    jQuery('#estes_setting_password').attr('title', 'Password');
    jQuery('#estes_setting_licnse_key').attr('title', 'Plugin License Key');

    /*
    * Add Title To Qoutes Setting Fields
    */

    jQuery('#estes_setting_label_as').attr('title', 'Label As');
    jQuery('#estes_settings_handling_fee').attr('title', 'Handling Fee / Markup');

    /*
         * Save Changes At Connection Section Action
         */

    jQuery(".estes_tab_section .button-primary").click(function () {
        var input = validateInput('.estes_tab_section');
        if (input === false) {
            return false;
        }
    });

    /*
     * Save Changes At Quote Section Action
     */

    jQuery('.estes_quote_section .button-primary').on('click', function () {

        jQuery(".updated").hide();
        jQuery('.error').remove();

        if (!estes_hold_at_terminal_fee_validation()) {
            return false;
        }

        var handling_fee = jQuery('#estes_settings_handling_fee').val();
        if (handling_fee === "%") {
            jQuery("#mainform .estes_quote_section").prepend('<div id="message" class="error inline estes_handlng_fee_error"><p><strong>Handling fee format should be 100.2000 or 10%.</strong></p></div>');
            jQuery('html, body').animate({
                'scrollTop': jQuery('.estes_handlng_fee_error').position().top
            });
            return false;
        }

        if (handling_fee.slice(handling_fee.length - 1) == '%') {
            handling_fee = handling_fee.slice(0, handling_fee.length - 1);
        }

        if (handling_fee === "") {
            return true;
        } else {
            if (isValidNumber(handling_fee) === false) {
                jQuery("#mainform .estes_quote_section").prepend('<div id="message" class="error inline estes_handlng_fee_error"><p><strong>Handling fee format should be 100.2000 or 10%.</strong></p></div>');
                jQuery('html, body').animate({
                    'scrollTop': jQuery('.estes_handlng_fee_error').position().top
                });
                return false;
            } else if (isValidNumber(handling_fee) === 'decimal_point_err') {
                jQuery("#mainform .estes_quote_section").prepend('<div id="message" class="error inline estes_handlng_fee_error"><p><strong>Handling fee format should be 100.2000 or 10% and only 4 digits are allowed after decimal point.</strong></p></div>');
                jQuery('html, body').animate({
                    'scrollTop': jQuery('.estes_handlng_fee_error').position().top
                });
                return false;
            } else {
                return true;
            }
        }
    });


    /*
     * Test connection
     */

    jQuery(".estes_tab_section .button-primary").before('<a href="javascript:void(0)" class="button-primary estes_test_connection">Test connection</a>');
    jQuery('.estes_test_connection').click(function (e) {
        var input = validateInput('.estes_tab_section');

        if (input === false) {
            return false;
        }

        var postForm = {
            'action': 'estes_test_connection',
            'estes_custom_no': jQuery('#estes_setting_customer_no').val(),
            'estes_username': jQuery('#estes_setting_username').val(),
            'estes_password': jQuery('#estes_setting_password').val(),
            'estes_license': jQuery('#estes_setting_licnse_key').val()
        };

        jQuery.ajax({
            type: 'POST',
            url: ajaxurl,
            data: postForm,
            dataType: 'json',

            beforeSend: function () {
                jQuery('#estes_setting_customer_no').css('background', 'rgba(255, 255, 255, 1) url("' + en_estes_admin_script.plugins_url + '/ltl-freight-quotes-estes-edition/warehouse-dropship/wild/assets/images/processing.gif") no-repeat scroll 50% 50%');
                jQuery('#estes_setting_username').css('background', 'rgba(255, 255, 255, 1) url("' + en_estes_admin_script.plugins_url + '/ltl-freight-quotes-estes-edition/warehouse-dropship/wild/assets/images/processing.gif") no-repeat scroll 50% 50%');
                jQuery('#estes_setting_password').css('background', 'rgba(255, 255, 255, 1) url("' + en_estes_admin_script.plugins_url + '/ltl-freight-quotes-estes-edition/warehouse-dropship/wild/assets/images/processing.gif") no-repeat scroll 50% 50%');
                jQuery('#estes_setting_licnse_key').css('background', 'rgba(255, 255, 255, 1) url("' + en_estes_admin_script.plugins_url + '/ltl-freight-quotes-estes-edition/warehouse-dropship/wild/assets/images/processing.gif") no-repeat scroll 50% 50%');
            },
            success: function (data) {
                jQuery(".estes_success_message").remove();
                jQuery(".estes_error_message").remove();
                jQuery("#message").hide();

                jQuery('#estes_setting_customer_no').css('background', '#fff');
                jQuery('#estes_setting_username').css('background', '#fff');
                jQuery('#estes_setting_password').css('background', '#fff');
                jQuery('#estes_setting_licnse_key').css('background', '#fff');

                if (data.message === "success") {
                    jQuery('.warning-msg').before('<div class="notice notice-success estes_success_message"><p><strong>Success! The test resulted in a successful connection.</strong></p></div>');
                } else if (data.message !== "failure" && data.message !== "success") {
                    jQuery('.warning-msg').before('<div class="notice notice-error estes_error_message"><p>Error!  ' + data.message + ' </p></div>');
                } else {
                    jQuery('.warning-msg').before('<div class="notice notice-error estes_error_message"><p>Error! Please verify credentials and try again.</p></div>');
                }
            }
        });
        e.preventDefault();
    });
    // fdo va
    jQuery('#fd_online_id_estes').click(function (e) {
        var postForm = {
            'action': 'estes_fd',
            'company_id': jQuery('#freightdesk_online_id').val(),
            'disconnect': jQuery('#fd_online_id_estes').attr("data")
        }
        var id_lenght = jQuery('#freightdesk_online_id').val();
        var disc_data = jQuery('#fd_online_id_estes').attr("data");
        if(typeof (id_lenght) != "undefined" && id_lenght.length < 1) {
            jQuery(".estes_error_message").remove();
            jQuery('.user_guide_fdo').before('<div class="notice notice-error estes_error_message"><p><strong>Error!</strong> FreightDesk Online ID is Required.</p></div>');
            return;
        }
        jQuery.ajax({
            type: "POST",
            url: ajaxurl,
            data: postForm,
            beforeSend: function () {
                jQuery('#freightdesk_online_id').css('background', 'rgba(255, 255, 255, 1) url("' + en_estes_admin_script.plugins_url + '/ltl-freight-quotes-estes-edition/warehouse-dropship/wild/assets/images/processing.gif") no-repeat scroll 50% 50%');
                },
            success: function (data_response) {
                if(typeof (data_response) == "undefined"){
                    return;
                }
                var fd_data = JSON.parse(data_response);
                jQuery('#freightdesk_online_id').css('background', '#fff');
                jQuery(".estes_error_message").remove();
                if((typeof (fd_data.is_valid) != 'undefined' && fd_data.is_valid == false) || (typeof (fd_data.status) != 'undefined' && fd_data.is_valid == 'ERROR')) {
                    jQuery('.user_guide_fdo').before('<div class="notice notice-error estes_error_message"><p><strong>Error! ' + fd_data.message + '</strong></p></div>');
                }else if(typeof (fd_data.status) != 'undefined' && fd_data.status == 'SUCCESS') {
                    jQuery('.user_guide_fdo').before('<div class="notice notice-success estes_success_message"><p><strong>Success! ' + fd_data.message + '</strong></p></div>');
                    window.location.reload(true);
                }else if(typeof (fd_data.status) != 'undefined' && fd_data.status == 'ERROR') {
                    jQuery('.user_guide_fdo').before('<div class="notice notice-error estes_error_message"><p><strong>Error! ' + fd_data.message + '</strong></p></div>');
                }else if (fd_data.is_valid == 'true') {
                    jQuery('.user_guide_fdo').before('<div class="notice notice-error estes_error_message"><p><strong>Error!</strong> FreightDesk Online ID is not valid.</p></div>');
                } else if (fd_data.is_valid == 'true' && fd_data.is_connected) {
                    jQuery('.user_guide_fdo').before('<div class="notice notice-error estes_error_message"><p><strong>Error!</strong> Your store is already connected with FreightDesk Online.</p></div>');

                } else if (fd_data.is_valid == true && fd_data.is_connected == false && fd_data.redirect_url != null) {
                    window.location = fd_data.redirect_url;
                } else if (fd_data.is_connected == true) {
                    jQuery('#con_dis').empty();
                    jQuery('#con_dis').append('<a href="#" id="fd_online_id_estes" data="disconnect" class="button-primary">Disconnect</a>')
                }
            }
        });
        e.preventDefault();
    });
});

// Weight threshold for LTL freight
if (typeof en_weight_threshold_limit != 'function') {
    function en_weight_threshold_limit() {
        // Weight threshold for LTL freight
        jQuery("#en_weight_threshold_lfq").keypress(function (e) {
            if (String.fromCharCode(e.keyCode).match(/[^0-9]/g) || !jQuery("#en_weight_threshold_lfq").val().match(/^\d{0,3}$/)) return false;
        });

        jQuery('#en_plugins_return_LTL_quotes').on('change', function () {
            if (jQuery('#en_plugins_return_LTL_quotes').prop("checked")) {
                jQuery('tr.en_weight_threshold_lfq').css('display', 'contents');
            } else {
                jQuery('tr.en_weight_threshold_lfq').css('display', 'none');
            }
        });

        jQuery("#en_plugins_return_LTL_quotes").closest('tr').addClass("en_plugins_return_LTL_quotes_tr");
        // Weight threshold for LTL freight
        var weight_threshold_class = jQuery("#en_weight_threshold_lfq").attr("class");
        jQuery("#en_weight_threshold_lfq").closest('tr').addClass("en_weight_threshold_lfq " + weight_threshold_class);

        // Weight threshold for LTL freight is empty
        if (jQuery('#en_weight_threshold_lfq').length && !jQuery('#en_weight_threshold_lfq').val().length > 0) {
            jQuery('#en_weight_threshold_lfq').val(150);
        }
    }
}

// Update plan
if (typeof en_update_plan != 'function') {
    function en_update_plan(input) {
        let action = jQuery(input).attr('data-action');
        jQuery.ajax({
            type: "POST",
            url: ajaxurl,
            data: {action: action},
            success: function (data_response) {
                window.location.reload(true);
            }
        });
    }
}

/*
         * Validate Input If Empty or Invalid
         */

function validateInput(form_id) {
    var has_err = true;
    jQuery(form_id + " input[type='text']").each(function () {

        var input = jQuery(this).val();
        var response = validateString(input);
        var errorText = jQuery(this).attr('title');
        var optional = jQuery(this).data('optional');

        var errorElement = jQuery(this).parent().find('.err');
        jQuery(errorElement).html('');

        optional = (optional === undefined) ? 0 : 1;
        errorText = (errorText != undefined) ? errorText : '';

        if ((optional == 0) && (response == false || response == 'empty')) {
            errorText = (response == 'empty') ? errorText + ' is required.' : 'Invalid input.';
            jQuery(errorElement).html(errorText);
        }
        has_err = (response != true && optional == 0) ? false : has_err;
    });
    return has_err;
}

/*
 * Check Input Value Is Not String
 */

function isValidNumber(value, noNegative) {
    if (typeof (noNegative) === 'undefined') noNegative = false;
    var isValidNumber = false;
    var validNumber = (noNegative == true) ? parseFloat(value) >= 0 : true;
    if ((value == parseInt(value) || value == parseFloat(value)) && (validNumber)) {
        if (value.indexOf(".") >= 0) {
            var n = value.split(".");
            if (n[n.length - 1].length <= 4) {
                isValidNumber = true;
            } else {
                isValidNumber = 'decimal_point_err';
            }
        } else {
            isValidNumber = true;
        }
    }
    return isValidNumber;
}

/*
 * Validate Input String
 */

function validateString(string) {
    if (string == '')
        return 'empty';
    else
        return true;

}

/**
 * Read a page's GET URL variables and return them as an associative array.
 */
function get_url_vars_estes_freight() {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for (var i = 0; i < hashes.length; i++) {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

function Estes_lfq_stop_special_characters(e) {
    // Allow: backspace, delete, tab, escape, enter and .
    if (jQuery.inArray(e.keyCode, [46, 9, 27, 13, 110, 190, 189]) !== -1 ||
        // Allow: Ctrl+A, Command+A
        (e.keyCode === 65 && (e.ctrlKey === true || e.metaKey === true)) ||
        // Allow: home, end, left, right, down, up
        (e.keyCode >= 35 && e.keyCode <= 40)) {
        // let it happen, don't do anything
        e.preventDefault();
        return;
    }
    // Ensure that it is a number and stop the keypress
    if ((e.shiftKey || (e.keyCode < 48 || e.keyCode > 90)) && (e.keyCode < 96 || e.keyCode > 105) && e.keyCode != 186 && e.keyCode != 8) {
        e.preventDefault();
    }
    if (e.keyCode == 186 || e.keyCode == 190 || e.keyCode == 189 || (e.keyCode > 64 && e.keyCode < 91)) {
        e.preventDefault();
        return;
    }
}

// Validation hold at terminal
function estes_hold_at_terminal_fee_validation() {
    var estes_hold_at_terminal_fee = jQuery('#estes_freight_hold_at_terminal_fee').val();
    var estes_hold_at_terminal_fee_regex = /^(-?[0-9]{1,4}%?)$|(\.[0-9]{1,2})%?$/;
    if (estes_hold_at_terminal_fee != '' && !estes_hold_at_terminal_fee_regex.test(estes_hold_at_terminal_fee) || estes_hold_at_terminal_fee.split('.').length - 1 > 1) {
        jQuery(".estes_quote_section").prepend('<div id="message" class="error inline estes_freight_hold_at_terminal_fee_error"><p><strong>Hold at terminal fee format should be 100.20 or 10%.</strong></p></div>');
        jQuery('html, body').animate({
            'scrollTop': jQuery('.estes_freight_hold_at_terminal_fee_error').position().top
        });
        jQuery("#estes_freight_hold_at_terminal_fee").css({'border-color': '#e81123'});
        return false;
    } else {
        return true;
    }
}