<?php
/**
 * ESTES COnnection Settings
 *
 * @package     ESTES Freight Quotes
 * @author      Eniture-Technology
 */
if (!defined('ABSPATH')) {
    exit;
}

/**
 * Estes Freight Connection Settings Tab Class
 */
class ESTES_Connection_Settings
{
    /**
     * Connection Settings Fields
     * @return array
     */

    function estes_connection_settings_tab()
    {
        echo '<div class="estes_tab_section">';
        $settings = array(
            'section_title_estes' => array(
                'name' => __('', 'estes_wc_settings'),
                'type' => 'title',
                'desc' => '<br> ',
                'id' => 'estes_setting_connection_title',
            ),

            'customer_no_estes' => array(
                'name' => __('Customer Number ', 'estes_wc_settings'),
                'type' => 'text',
                'desc' => __('', 'estes_wc_settings'),
                'id' => 'estes_setting_customer_no'
            ),

            'estes_username' => array(
                'name' => __('Username ', 'estes_wc_settings'),
                'type' => 'text',
                'desc' => __('', 'estes_wc_settings'),
                'id' => 'estes_setting_username'
            ),

            'estes_password' => array(
                'name' => __('Password ', 'estes_wc_settings'),
                'type' => 'text',
                'desc' => __('', 'estes_wc_settings'),
                'id' => 'estes_setting_password'
            ),

            'estes_licnse_key' => array(
                'name' => __('Plugin License Key ', 'estes_wc_settings'),
                'type' => 'text',
                'desc' => __('Obtain a License Key from <a href="https://eniture.com/woocommerce-estes-ltl-freight/" target="_blank" >eniture.com </a>', 'ups_ltl_wc_settings'),
                'id' => 'estes_setting_licnse_key'
            ),

            'section_end_ups_ltl' => array(
                'type' => 'sectionend',
                'id' => 'ups_ltl_access_level'
            ),
        );
        return $settings;
    }
}